package javax.swing.text.html;

import javax.swing.text.View;
import java.awt.Container;
import javax.swing.text.JTextComponent;
import java.awt.Shape;
import java.awt.Graphics;
import javax.swing.text.Element;

class NoFramesView extends BlockView
{
    boolean visible;
    
    public NoFramesView(Element element, int n) {
        super(element, n);
        this.visible = false;
    }
    
    @Override
    public void paint(Graphics graphics, Shape shape) {
        Container container = this.getContainer();
        if (container != null && this.visible != ((JTextComponent)container).isEditable()) {
            this.visible = ((JTextComponent)container).isEditable();
        }
        if (!this.isVisible()) {
            return;
        }
        super.paint(graphics, shape);
        return;
    }
    
    @Override
    public void setParent(View parent) {
        if (parent != null) {
            Container container = parent.getContainer();
            if (container != null) {
                this.visible = ((JTextComponent)container).isEditable();
            }
        }
        super.setParent(parent);
    }
    
    @Override
    public boolean isVisible() {
        return this.visible;
    }
    
    @Override
    protected void layout(int width, int height) {
        if (!this.isVisible()) {
            return;
        }
        super.layout(width, height);
        return;
    }
    
    @Override
    public float getPreferredSpan(int n) {
        if (!this.visible) {
            return 0.0f;
        }
        return super.getPreferredSpan(n);
    }
    
    @Override
    public float getMinimumSpan(int n) {
        if (!this.visible) {
            return 0.0f;
        }
        return super.getMinimumSpan(n);
    }
    
    @Override
    public float getMaximumSpan(int n) {
        if (!this.visible) {
            return 0.0f;
        }
        return super.getMaximumSpan(n);
    }
}
